/// Insanichess game logic.
///
/// This library is meant to be used both from client and from server.
/// It provides all the necessary game logic regarding the Insanichess game.

library insanichess;

export 'src/board/board.dart';
export 'src/board/move.dart';
export 'src/board/square.dart';
export 'src/game/game.dart';
export 'src/game/game_history.dart';
export 'src/game/game_status.dart';
export 'src/pieces/black_bishop.dart';
export 'src/pieces/black_king.dart';
export 'src/pieces/black_knight.dart';
export 'src/pieces/black_pawn.dart';
export 'src/pieces/black_queen.dart';
export 'src/pieces/black_rook.dart';
export 'src/pieces/definitions/black_piece.dart';
export 'src/pieces/definitions/piece.dart';
export 'src/pieces/definitions/piece_color.dart';
export 'src/pieces/definitions/piece_type.dart';
export 'src/pieces/definitions/white_piece.dart';
export 'src/pieces/mixins/bishop.dart';
export 'src/pieces/mixins/king.dart';
export 'src/pieces/mixins/knight.dart';
export 'src/pieces/mixins/pawn.dart';
export 'src/pieces/mixins/queen.dart';
export 'src/pieces/mixins/rook.dart';
export 'src/pieces/white_bishop.dart';
export 'src/pieces/white_king.dart';
export 'src/pieces/white_knight.dart';
export 'src/pieces/white_pawn.dart';
export 'src/pieces/white_queen.dart';
export 'src/pieces/white_rook.dart';
